<?php 
defined( 'ABSPATH' ) or die( 'Error' );
class Album extends CoreObject
{	
	public $ReleaseDate;
	public $Label;
	public $AmazonLink;
	public $ItunesLink;
	public $YoutubeVideo;
	public $BandName;
	public $Spotify;
	public $SoundCloud;
	public $GoogleMusic;
	public $Genre;
	public $Duration;
	public $ReleaseType;
	public $ReleaseFormats;
	
	public $Songs;
	
	
	public function ByID($postid) {
		$post = get_post($postid);
		return self::Get()->ByPost($post);
	}
	public function ByPost($post) {
		$this->ID = $post->ID;
		$this->Title = $post->post_title;
		$this->Slug = $post->post_name;
		$this->ReleaseDate = get_post_meta( $post->ID, 'album_releasedate', true );
		$this->Amazon = get_post_meta( $post->ID, 'album_amazonurl', true );
		$this->Itunes = get_post_meta( $post->ID, 'album_itunesurl', true );
		$this->Label = get_post_meta( $post->ID, 'album_recordlabel', true );
		$this->YoutubeVideo = get_post_meta( $post->ID, 'album_youtubeurl', true );
		$this->BandName = get_post_meta( $post->ID, 'album_bandname', true );
		$this->Spotify = get_post_meta( $post->ID, 'album_spotify', true );
		$this->SoundCloud = get_post_meta( $post->ID, 'album_soundcloud', true );
		$this->GoogleMusic = get_post_meta( $post->ID, 'album_googleplaymusic', true );
		$this->Description = $post->post_content;
		$this->Genre = get_post_meta( $post->ID, 'album_genre', true );
		$this->Duration = get_post_meta( $post->ID, 'album_duration', true );
		$this->ReleaseFormats = get_post_meta( $post->ID, 'album_releaseformats', true );
		$this->ReleaseType = get_post_meta( $post->ID, "album_releasetype", true);
		return $this;
	}
	
	public function GetSongs()
	{
		if($this->Songs != null) return $this->Songs;
		$args = array(
			'post_type' => 'song',
			'orderby' => 'meta_value_num',
			'meta_key' => 'song_tracknumber',
			'order' => 'ASC',
			'meta_query' => array(
				array(	'key' => 'song_albumid', 
						'value' => $this->ID,
						'compare' => '=', 
						'type' => 'NUMERIC',)));
					
		//$query = new WP_Query( "post_type=song&meta_key=song_albumid&meta_value=".$this->ID."&order=ASC&orderby='meta_key=song_tracknumber'" );
		$query = new WP_Query( $args );
		$songresults = $query->get_posts();
		
		$songs = array();
		foreach($songresults as $song) {
			$songs[] = Song::Get()->ByPost($song);
		}
		
		$this->Songs = $songs;
		return $songs;
	}
	
	public function GetSongCount()
	{
		$query = new WP_Query( "post_type=song&meta_key=song_albumid&meta_value=".$this->ID."&orderby='meta_key=song_tracknumber'&order=ASC" );;
		return $query->found_posts;
	}
	
	public function GetComposers()
	{
		$composermeta = get_post_meta( $this->ID, 'album_composers', true );
		return json_decode($composermeta, true);
	}
	
	public function GenerateBreadcrumbs()
	{
		ob_start();
		?>
		<div id="postbreadcrumbs">
			<ul itemscope itemtype="http://schema.org/BreadcrumbList">
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<a itemprop="url" href="/"><span itemprop="name">Home</span></a>
					<meta itemprop="position" content="1" />
				</li>
				<li class="breadcrumbseparator"> > </li>
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<a itemprop="url" href="/album"><span itemprop="name">Albums</span></a>
					<meta itemprop="position" content="2" />
				</li>
				<li class="breadcrumbseparator"> > </li>
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<a itemprop="url" href="/"><span itemprop="name"><?php echo $this->Title;?></span></a>
					<meta itemprop="position" content="3" />
				</li>
			</ul>
			<div style="clear:both"></div>
		</div>
		<?php 
		$crumbs = ob_get_clean();
		return $crumbs;
	}
	
	public function GeneratePostMetaDetails()
	{	
		return "";
		return "<span id='postpublished'>Released : ".$this->ReleaseDate."</span> ";
	}
}