<?php 
class BandMember extends CoreObject
{
	public $Instrument;
	public $NickName;
	public $DateJoined;
	public $DateLeft;
	
	public function ByID($postid) {
		$post = get_post($postid);
		return self::Get()->ByPost($post);
	}
	public function ByPost($post) {
		$this->ID = $post->ID;
		$this->Title = $post->post_title;
		$this->Slug = $post->post_name;
		$this->Description = $post->post_content;
		$this->Instrument = get_post_meta( $post->ID, 'bandmember_instrument', true );
		$this->NickName = get_post_meta( $post->ID, 'bandmember_nickname', true );
		$this->DateJoined = get_post_meta( $post->ID, 'bandmember_datejoined', true );
		$this->DateLeft = get_post_meta( $post->ID, 'bandmember_dateleft', true );
		return $this;
	}
	
	public function GenerateBreadcrumbs()
	{
		ob_start();
		?>
		<div id="postbreadcrumbs">
			<ul itemscope itemtype="http://schema.org/BreadcrumbList">
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<a itemprop="url" href="/"><span itemprop="name">Home</span></a>
					<meta itemprop="position" content="1" />
				</li>
				<li class="breadcrumbseparator"> > </li>
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<a itemprop="item" href="/bandmember"><span itemprop="name">Band Members</span></a>
					<meta itemprop="position" content="2" />
				</li>
				<li class="breadcrumbseparator"> > </li>
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<span itemprop="name"><?php echo $this->Title;?></span>
					<meta itemprop="position" content="3" />
				</li>
			</ul>
			<div style="clear:both"></div>
		</div>
		<?php 
		$albumcrumbs = ob_get_clean();
		
		return $albumcrumbs;
	}
	
	public function GetGear()
	{
		$query = new WP_Query( "post_type=gear&meta_key=gear_bandmember&meta_value=".$this->ID."&order=ASC" );
		$gearresults = $query->get_posts();
		
		$membergear = array();
		foreach($gearresults as $gear) {
			$membergear[] = (new Gear)->ByPost($gear);
		}
		
		return $membergear;
	}
	
	public function GeneratePostMetaDetails()
	{	
		return "";
	}
}