<?php 
class Gear extends CoreObject
{
	public $Model;
	public $DatePurchased;
	public $Owner;
	public $YearManufactured;
	
	public function ByID($postid) {
		$post = get_post($postid);
		return self::Get()->ByPost($post);
	}
	public function ByPost($post) {
		$this->ID = $post->ID;
		$this->Title = $post->post_title;
		$this->Slug = $post->post_name;
		$this->Description = $post->post_content;
		$this->Model = get_post_meta( $post->ID, 'gear_model', true );
		$this->DatePurchased = get_post_meta( $post->ID, 'gear_datepurchased', true );
		$this->Owner = get_post_meta( $post->ID, 'gear_bandmember', true );
		$this->YearManufactured = get_post_meta( $post->ID, 'gear_yearmanufactured', true );
		return $this;
	}
	
	public function GenerateBreadcrumbs()
	{
		ob_start();
		?>
		<div id="postbreadcrumbs">
			<ul itemscope itemtype="http://schema.org/BreadcrumbList">
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<a itemprop="url" href="/"><span itemprop="name">Home</span></a>
					<meta itemprop="position" content="1" />
				</li>
				<li class="breadcrumbseparator"> > </li>
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<a itemprop="url" href="/gear/"><span itemprop="name">Gear</span></a>
					<meta itemprop="position" content="2" />
				</li>
				<li class="breadcrumbseparator"> > </li>
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<a itemprop="url" href="/"><span itemprop="name"><?php echo $this->Title;?></span></a>
					<meta itemprop="position" content="3" />
				</li>
			</ul>
			<div style="clear:both"></div>
		</div>
		<?php 
		$crumbs = ob_get_clean();
		return $crumbs;
	}
	public function GeneratePostMetaDetails()
	{	
		return "";
	}
}