<?php 
class Gig extends CoreObject
{
	public $Location;
	public $GoogleMaps;
	public $GigDate;
	public $DoorsOpen;
	public $StartTime;
	public $AdmissionCost;
	public $AgeRestriction;
	public $FacebookUrl;
	public $Address;
	
	public function ByID($postid) {
		$post = get_post($postid);
		return self::ByPost($post);
	}
	public function ByPost($post) {
		$this->ID = $post->ID;
		$this->Title = $post->post_title;
		$this->Slug = $post->post_name;
		$this->Description = $post->post_content;
		$this->Location = get_post_meta( $post->ID, 'gig_location', true );
		$this->GoogleMaps = get_post_meta( $post->ID, 'gig_googlemaps', true );
		$this->GigDate = get_post_meta( $post->ID, 'gig_date', true );
		$this->DoorsOpen = get_post_meta( $post->ID, 'gig_doorsopen', true );
		$this->StartTime = get_post_meta( $post->ID, 'gig_starttime', true );
		$this->AdmissionCost = get_post_meta( $post->ID, 'gig_admission', true );
		$this->AgeRestriction = get_post_meta( $post->ID, 'gig_agerestriction', true );
		$this->FacebookUrl = get_post_meta( $post->ID, 'gig_facebookurl', true );		
		$this->Address = get_post_meta( $post->ID, 'gig_address', true );		
		return $this;
	}
	
	//only a band of super humans could play a gig for days. Assume a gig will end after midnight and end the next day
	function generateEndDate()
	{
		return date('Y-m-d', strtotime($this->GigDate . ' +1 day'));
	}
	
	public function GenerateBreadcrumbs()
	{
		ob_start();
		?>
		<div id="postbreadcrumbs">
			<ul itemscope itemtype="http://schema.org/BreadcrumbList">
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<a itemprop="url" href="/"><span itemprop="name">Home</span></a>
					<meta itemprop="position" content="1" />
				</li>
				<li class="breadcrumbseparator"> > </li>
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<a itemprop="url" href="/gig/"><span itemprop="name">Gigs</span></a>
					<meta itemprop="position" content="2" />
				</li>
				<li class="breadcrumbseparator"> > </li>
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<a itemprop="url" href="/"><span itemprop="name"><?php echo $this->Title;?></span></a>
					<meta itemprop="position" content="3" />
				</li>
			</ul>
			<div style="clear:both"></div>
		</div>
		<?php 
		$crumbs = ob_get_clean();
		return $crumbs;
	}

	public function GeneratePostMetaDetails()
	{	
		return "";
	}
}