<?php 
class Song extends CoreObject
{
	public $AlbumID;
	public $TrackNumber;
	public $TrackLength;
	public $DateRecorded;
	public $LocationRecorded;
	public $Itunes;
	public $Amazon;
	public $SoundCloud;
	public $Youtube;
	public $Lyrics;
	public $GoogleMusic;
	public $Spotify;
	public $MP3;
	public $FeaturedAlbumImage;
	
	//Cache object to save multiple calls
	public $Album;
	
	public function ByID($postid) {
		$post = get_post($postid);
		return self::ByPost($post);
	}
	public function ByPost($post) {
		$this->ID = $post->ID;
		$this->Title = $post->post_title;
		$this->Slug = $post->post_name;
		$this->Description = $post->post_content;
		$this->AlbumID = get_post_meta( $post->ID, 'song_albumid', true );
		$this->TrackNumber =  get_post_meta( $post->ID, 'song_tracknumber', true );
		$this->Itunes = get_post_meta( $post->ID, 'song_itunes', true );
		$this->TrackLength = get_post_meta( $post->ID, 'song_tracklength', true );
		$this->Amazon = get_post_meta( $post->ID, 'song_amazon', true );
		$this->DateRecorded = get_post_meta( $post->ID, 'song_daterecorded', true );
		$this->LocationRecorded = get_post_meta( $post->ID, 'song_locationrecorded', true );
		$this->Youtube = get_post_meta( $post->ID, 'song_youtube', true );
		$this->SoundCloud = get_post_meta( $post->ID, 'song_soundcloud', true );		
		$this->Lyrics = get_post_meta( $post->ID, 'song_lyrics', true );
		$this->GoogleMusic = get_post_meta( $post->ID, 'song_googlemusic', true );
		$this->Spotify = get_post_meta( $post->ID, 'song_spotify', true );
		$this->MP3 = get_post_meta( $post->ID, 'song_mp3path', true );
		$this->FeaturedAlbumImage = get_post_meta( $post->ID, 'song_albumimage', true );
		return $this;
	}
	
	public function GetAlbum()
	{
		if($this->Album != null) return $this->Album;
		$Album = Album::Get()->ByID($this->AlbumID);
		$this->Album = $Album;
		return $this->Album;
	}
	
	public function GetComposers()
	{
		$composermeta = get_post_meta( $this->ID, 'album_composers', true );
		return json_decode($composermeta, true);
	}
	
	public function GenerateBreadcrumbs()
	{
		$Album = $this->GetAlbum();
		ob_start();
		?>
		<div id="postbreadcrumbs">
			<ul itemscope itemtype="http://schema.org/BreadcrumbList">
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<a itemprop="url" href="/"><span itemprop="name">Home</span></a>
					<meta itemprop="position" content="1" />
				</li>
				<li class="breadcrumbseparator"> > </li>
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<a itemprop="url" href="/album"><span itemprop="name">Albums</span></a>
					<meta itemprop="position" content="2" />
				</li>
				<li class="breadcrumbseparator"> > </li>
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<a itemscope itemtype="http://schema.org/MusicAlbum" itemprop="item" href="/album/<?php echo $Album->Slug;?>"><span itemprop="name"><?php echo $Album->Title;?></span></a>
					<meta itemprop="position" content="3" />
				</li>
				<li class="breadcrumbseparator"> > </li>
				<li itemprop="itemListElement" itemscope itemtype="http://schema.org/ListItem">
					<span itemprop="name"><?php echo $this->Title;?></span>
					<meta itemprop="position" content="4" />
				</li>
			</ul>
			<div style="clear:both"></div>
		</div>
		<?php 
		$albumcrumbs = ob_get_clean();
		
		return $albumcrumbs;
	}
	
	public function GeneratePostMetaDetails()
	{	
		return "";
	}
	
	public function GetFeaturedImage($returnhtml = false)
	{
		$image = parent::GetFeaturedImage($returnhtml);
		if($this->FeaturedAlbumImage != "off" && ($image == null || $image == ""))
		{
			$album = Album::Get()->ByID($this->AlbumID);
			return $album->GetFeaturedImage($returnhtml);
		}
		else return $image;
	}
}