<?php 
defined( 'ABSPATH' ) or die( 'Error' );
//START DECLARE THE POST TYPE
add_action( 'init', 'bandmanager_create_albums' );
function bandmanager_create_albums() {
	register_post_type( 'album',
		array('labels' => array(
				'name' => 'Albums',
				'singular_name' => 'Album',
				'add_new' => 'Add New',
				'add_new_item' => 'Add New Album',
				'edit' => 'Edit',
				'edit_item' => 'Edit Album',
				'new_item' => 'New Album',
				'view' => 'View',
				'view_item' => 'View Albums',
				'search_items' => 'Search Albums',
				'not_found' => 'No Album found',
				'not_found_in_trash' => 'No Album found in Trash',
				'parent' => 'Parent Album'
			),
 
			'public' => true,
			'menu_position' => 40,
			'supports' => array( 'title', 'editor', 'thumbnail', 'comments', 'revisions'),
			'taxonomies' => array('post_tag'),
			'menu_icon' => 'dashicons-album',
			'has_archive' => true
		)
	);
}
//END DECLARE THE POST TYPE


###################################################################################
###################################################################################
#								META FIELDS
###################################################################################
###################################################################################
add_action( 'add_meta_boxes', 'bandmanager_customAlbumFields' );
add_action( 'save_post', 'bandmanager_albumSaveFields' );
function bandmanager_customAlbumFields() {
	add_meta_box('AlbumFields',__('Album Information', 'dx2bandtheme'),'bandmanager_albumFieldsCallback', "album", 'side');
	if(get_option('bandmanager_showbandmembers') == "on") add_meta_box('Bandmembers',__('Composers / Contributors', 'dx2bandtheme'),'bandmanager_composersBox', "album");
	add_meta_box('TrackList',__('Track List', 'dx2bandtheme'),'bandmanager_albumTrackListing', "album");
}


function bandmanager_albumFieldsCallback($post)
{
	wp_nonce_field( 'customNBFieldsSaveMetaBoxData', 'customNBFieldsSaveMetaBoxNonce' );
	$album_releasedate = get_post_meta( $post->ID, 'album_releasedate', true );
	$album_amazonurl = get_post_meta( $post->ID, 'album_amazonurl', true );
	$album_itunesurl = get_post_meta( $post->ID, 'album_itunesurl', true );
	$album_recordlabel = get_post_meta( $post->ID, 'album_recordlabel', true );
	$album_youtubeurl = get_post_meta( $post->ID, 'album_youtubeurl', true );
	$album_googleplaymusic = get_post_meta( $post->ID, 'album_googleplaymusic', true );
	$album_spotify = get_post_meta( $post->ID, 'album_spotify', true );
	$album_bandname = get_post_meta( $post->ID, 'album_bandname', true );
	if($post->post_name == null || $post->post_name = "") $album_bandname = get_option('band_name');
	$album_soundcloud = get_post_meta( $post->ID, 'album_soundcloud', true );
	$album_duration = get_post_meta( $post->ID, 'album_duration', true );
	$releaseformats = get_post_meta( $post->ID, 'album_releaseformats', true );
	$album_releasetype = get_post_meta( $post->ID, "album_releasetype", true);

	$album_releaseformats = array();
	foreach(explode(",", $releaseformats) as $format)
	{
		$album_releaseformats[$format] = true;
	}
	?>

	<table class="bandmanagercustomfields">
	<tr><th>Band Name</th></tr><tr><td><input type="text" name="album_bandname" value="<?php echo $album_bandname;?>"></td></tr>
	<tr><th>Release Date</th></tr><tr><td><input type="text" name="album_releasedate" id="datepicker" value="<?php echo $album_releasedate;?>"></td></tr>
	<tr><th>Amazon Music</th></tr><tr><td><input type="text" name="album_amazonurl" value="<?php echo $album_amazonurl;?>"></td></tr>
	<tr><th>Itunes</th></tr><tr><td><input type="text" name="album_itunesurl" value="<?php echo $album_itunesurl;?>"></td></tr>
	<tr><th>Google Play Music</th></tr><tr><td><input type="text" name="album_googleplaymusic" value="<?php echo $album_googleplaymusic;?>"></td></tr>
	<tr><th>Spotify</th></tr><tr><td><input type="text" name="album_spotify" value="<?php echo $album_spotify;?>"></td></tr>
	<tr><th>SoundCloud</th></tr><tr><td><input type="text" name="album_soundcloud" value="<?php echo $album_soundcloud;?>"></td></tr>
	<tr><th>Record Label</th></tr><tr><td><input type="text" name="album_recordlabel" value="<?php echo $album_recordlabel;?>"></td></tr>
	<tr><th>Youtube</th></tr><tr><td><input type="text" name="album_youtubeurl" value="<?php echo $album_youtubeurl;?>"></td></tr>
	<tr><th>Duration</th></tr><tr><td><input type="text" name="album_duration" value="<?php echo $album_duration;?>"></td></tr>
	<tr><th>Release Type</th></tr>
	<tr><td>
		<select name="album_releasetype">
			<option value="single" <?php if($album_releasetype == "single") echo "selected";?>>Single</option>
			<option value="ep" <?php if($album_releasetype == "ep") echo "selected";?>>EP</option>
			<option value="album" <?php if($album_releasetype == "album") echo "selected";?>>Studio Album</option>
			<option value="livealbum" <?php if($album_releasetype == "livealbum") echo "selected";?>>Live Album</option>
			<option value="soundtrack" <?php if($album_releasetype == "soundtrack") echo "selected";?>>Soundtrack</option>
		</select>
	</td></tr>
	<tr><th>Release Formats</th></tr>
	<tr><td>
		<ul id="albumadminformats">
			<li><input type="checkbox" name="release_format_cd" <?php if(isset($album_releaseformats["cd"])) echo "checked";?>>Compact Disc
			<li><input type="checkbox" name="release_format_digital" <?php if(isset($album_releaseformats["digital"])) echo "checked";?>>Digital
			<li><input type="checkbox" name="release_format_usb" <?php if(isset($album_releaseformats["usb"])) echo "checked";?>>USB
			<li><input type="checkbox" name="release_format_12vinyl" <?php if(isset($album_releaseformats["12vinyl"])) echo "checked";?>>12" Vinyl
			<li><input type="checkbox" name="release_format_10vinyl" <?php if(isset($album_releaseformats["10vinyl"])) echo "checked";?>>10" Vinyl
			<li><input type="checkbox" name="release_format_7vinyl" <?php if(isset($album_releaseformats["7vinyl"])) echo "checked";?>>7" Vinyl
			<li><input type="checkbox" name="release_format_cassette" <?php if(isset($album_releaseformats["cassette"])) echo "checked";?>>Cassette
		<ul>
	</td></tr>
	</table>
	<?php
}

function bandmanager_composersBox($post)
{
	$args = array('post_type' => 'bandmember');
	$bandmemberlist = get_posts( $args ); 
	$bandmemberselect = "<option></option>";
	foreach($bandmemberlist as $member)
	{
		$bandmemberselect .= "<option value='".$member->ID."'>".$member->post_title."</option>";
	}
	$bandmemberselect = "<select id='addcomposerbandmember' name='addcomposerbandmember'>".$bandmemberselect."</select>";
	?>

	<div id="addBandMemberControl">
		<span style="float:right"><a href="javascript:toggleAddComposer()">X</a></span>
		<strong id="addBandMemberControlTitle">Add Composer To Album </strong><a class="dx2themetip" style="margin-left:10px;" title="View Page Type Documentation" target="_blank" href="https://dx2systems.com/wiki/adding-record-composers/"><span class="dashicons dashicons-lightbulb"></span> Help</a>
		<p>Add information about someone who played a part in the composition or production of this album below. The member field will link the composer to a band member</p>
		<table>
			<tr><td><div id="addcomposerimgpreview"></div></td></tr>
			<tr><th><a href="javascript:wpmediaupload('addcomposerimage','addcomposerimgpreview', 1)">Add Image</a></th></tr>
			<tr><th>Name</th></tr><tr><td><input type="text" id="addcomposername"></td></tr>
			<tr><th>Role Title</th></tr><tr><td><input type="text" id="addcomposerrole"></td></tr>
			<tr><th>Description</th></tr><tr><td><textarea id="addcomposerdescription"></textarea></td></tr>
			<tr><th>Member</th></tr><tr><td><?php echo $bandmemberselect;?></td></tr>
			<input type="hidden" name="addcomposerimage" id="addcomposerimage"></td></tr>
			<tr><td><input type="button" value="Submit" onclick="addNewComposer()"></td></tr>
		</table>
		<div style="clear:both"></div>
	</div>
	<div id="addComposerControls">
		<span style="float:right"><a href="javascript:toggleAddComposer()">Add New</a></span>
	</div>
	<div id="adminCurrentComposerList">
	<p>List of any people who contributed to this album in some way.</p>
		<?php 	
		$composermeta = get_post_meta( $post->ID, 'album_composers', true );
		$composers = json_decode($composermeta, true);
		//var_dump($composermeta);
		if(count($composers) == 0) echo "<p>No composers have been added to this album.</p>";
		else {
			$count = 1;
			foreach($composers as $composer)
			{
				?><div class='adminAlbumComposeTile' id='adminAlbumComposeTile<?php echo $count;?>'>
				<a class="composerRemove" href="javascript:deleteComposer(<?php echo $count;?>)">Remove</a>
				<table>
					<?php 
					if(isset($composer["image"]) && $composer["image"] != "") {
						echo '<tr><th><div id="composerimagepreview'.$count.'"><img src="'.$composer["image"].'"/></div></th></tr>';
						echo "<input type='hidden' id='composerimage".$count."' name='composerimage".$count."' value='".$composer["image"]."'>";
						echo "<a href='javascript:wpmediaupload(\"composerimage".$count."\",\"composerimagepreview".$count."\", 1)'>Change Image</a>";
					} 
					else {
						echo '<tr><th><div id="composerimagepreview'.$count.'"></div></th></tr>';
						echo "<input type='hidden' id='composerimage".$count."' name='composerimage".$count."'>";
						echo "<a href='javascript:wpmediaupload(\"composerimage".$count."\",\"composerimagepreview".$count."\", 1)'>Set Image</a>";	
					}?>
					<tr><th>Name</th></tr><tr><td><input type='text' name='composername<?php echo $count;?>' value='<?php echo $composer['name'];?>'></td></tr>
					<tr><th>Role</th></tr><tr><td><input type='text' name='composerrole<?php echo $count;?>' value='<?php echo $composer['role'];?>'></td></tr>
					<tr><th>Description</th></tr><tr><td><textarea name='composerdescription<?php echo $count;?>'><?php echo $composer['description'];?></textarea></td></tr>
					<tr><th>Band Member</th></tr><tr><td><select name='composerbandmember<?php echo $count;?>'>
					<?php 
						echo "<option></option>";
						foreach($bandmemberlist as $member) {
							$selected = "";
							if($member->ID == $composer['bandmember']) $selected = "selected";
							echo "<option value='".$member->ID."' ".$selected.">".$member->post_title."</option>";
						}
					?>
					</select></td></tr>
				</table></div>
				<?php
				$count ++;
			}
		}
		?>
	</div>
	<input type="hidden" id="totalExistingComposers" name= "totalExistingComposers" value="<?php echo count($composers);?>">
	<div style="clear:both"></div>
	<a class="dx2themetip" style="margin-left:10px;" title="View Page Type Documentation" target="_blank" href="https://dx2systems.com/wiki/adding-record-composers/"><span class="dashicons dashicons-lightbulb"></span> View Record Composer Documentation</a>
	<?php
}

function bandmanager_albumSaveFields($post_id)
{
	if(bandmanager_validateMetaSave($post_id) == false) return;
	bandmanager_saveMetaField($post_id, "album_releasedate");
	bandmanager_saveMetaField($post_id, "album_amazonurl");
	bandmanager_saveMetaField($post_id, "album_itunesurl");
	bandmanager_saveMetaField($post_id, "album_recordlabel");
	bandmanager_saveMetaField($post_id, "album_youtubeurl");
	bandmanager_saveMetaField($post_id, "album_googleplaymusic");
	bandmanager_saveMetaField($post_id, "album_spotify");
	bandmanager_saveMetaField($post_id, "album_bandname");
	bandmanager_saveMetaField($post_id, "album_soundcloud");
	bandmanager_saveMetaField($post_id, 'album_duration');
	bandmanager_saveMetaField($post_id, "album_releasetype");
	
	$formats = "";
	if(isset($_POST['release_format_cd'])) $formats .= "cd,";
	if(isset($_POST['release_format_digital'])) $formats .= "digital,";
	if(isset($_POST['release_format_usb'])) $formats .= "usb,";
	if(isset($_POST['release_format_12vinyl'])) $formats .= "12vinyl,";
	if(isset($_POST['release_format_10vinyl'])) $formats .= "10vinyl,";
	if(isset($_POST['release_format_7vinyl'])) $formats .= "7vinyl,";
	if(isset($_POST['release_format_cassette'])) $formats .= "cassette,";
	
	$formats = rtrim($formats, ",");
	update_post_meta($post_id, "album_releaseformats", $formats);
	
	$composerdivids = array();
	$composers = array();
	foreach($_POST as $key => $val)
	{
		//echo substr($key, 0, 12)."<br>";
		if(substr($key, 0, 12) == "composername") 
		{
			$currentindexid = substr($key, 12, 13);
			$composerdivids[] = $currentindexid;
			$composer = array();
			$composer["name"] = $_POST['composername'.$currentindexid];
			$composer["role"] = $_POST['composerrole'.$currentindexid];
			$composer["description"] = $_POST['composerdescription'.$currentindexid];
			$composer["bandmember"] = $_POST["composerbandmember".$currentindexid];
			$composer["image"] = "";
			if(isset($_POST["composerimage".$currentindexid])) $composer["image"] = $_POST["composerimage".$currentindexid];
			$composers[] = $composer;
		}
	}
	
	update_post_meta($post_id, "album_composers", sanitize_text_field(json_encode($composers)));
	//var_dump(get_post_meta( $post_id, 'album_composers', true ));
	//die();
}

function bandmanager_albumTrackListing($post)
{
	//$album = Album::Get()->ByPost($post);
	$album = (new Album)->ByPost($post);
	$songs = $album->GetSongs();
	//var_dump($songs);
	echo "<a class='dx2themetip' style='float:right;' title='Help - Learn More about this section' href='https://dx2systems.com/wiki/add-songs-album-track-list/'><span class='dashicons dashicons-lightbulb'></span></a>";
	if(count($songs) == 0) echo "<p>No songs added to this album. To add songs, please create a new song and assign this album as the songs album name. Songs will then automatically show up here once they are associated with the album.</p>";
	echo "<table>";
	foreach($songs as $song)
	{
		echo "<tr><td>#".$song->TrackNumber.". </td><td><a href='/wp-admin/post.php?post=".$song->ID."&action=edit'>".$song->Title."</a></td></tr>";
	}
	echo "</table><br>";
}

###################################################################################
###################################################################################
#									ADMIN MENU
###################################################################################
###################################################################################

add_filter('manage_album_posts_columns', 'bandmanager_albumlist_columns');
function bandmanager_albumlist_columns($columns){
	$columns = array(
	'cb' => '<input type="checkbox" />',
	'album_artwork' => __('Artwork', 'dx2-band-theme'),
	'title' => __('Title', 'dx2-band-theme'),
	'album_trackcount' => __('Track Count', 'dx2-band-theme'),
	'album_releasedate' => __('Release Date', "dx2-band-theme"),
	);
	return $columns;
}

###################################################################################
###################################################################################
#									SHORTCODES
###################################################################################
###################################################################################

function bandmanager_albums_func( $atts ){
	$html = "";
	$style=0;
	if(isset($atts['style'])) $style = $atts['style'];
	
	//if there is a limit then it is a multi file
	if(isset($atts['limit']))
	{
		$posts = bandmanager_getMultiplePosts($atts['limit'], "album");
	}
	
	//slug to pull a single item
	if(isset($atts['slug']))
	{
		$posts = getPostBySlug($slug, "album");
	}
	
	//if the query has successfully returned a post type, render them based on the style choice.
	switch($style)
	{
		default:
			if($posts != null)
			{
				foreach($posts->posts as $post)
				{
					$postid = $post->ID;
					$url = wp_get_attachment_url( get_post_thumbnail_id($postid) );
					$html .= $url.print_r($post, true);
				}
			}
		break;
	}
	
	return $html;
}
add_shortcode( 'albums', 'bandmanager_albums_func' );