<?php 
defined( 'ABSPATH' ) or die( 'Error' );
add_action( 'init', 'bandmanager_create_band_members' );
function bandmanager_create_band_members() {
	register_post_type( 'bandmember',
		array('labels' => array(
				'name' => 'Band Members',
				'singular_name' => 'Band Member',
				'add_new' => 'Add New',
				'add_new_item' => 'Add New Band Member',
				'edit' => 'Edit',
				'edit_item' => 'Edit Band Member',
				'new_item' => 'New Band Member',
				'view' => 'View',
				'view_item' => 'View Band Members',
				'search_items' => 'Search Band Members',
				'not_found' => 'No Band Member found',
				'not_found_in_trash' => 'No Band Member found in Trash',
				'parent' => 'Parent Band Member'
			),
 
			'public' => true,
			'menu_position' => 40,
			'supports' => array( 'title', 'editor', 'thumbnail' , 'revisions'),
			'taxonomies' => array( '' ),
			'menu_icon' => 'dashicons-groups',
			'has_archive' => true
		)
	);
}

###################################################################################
###################################################################################
#								META FIELDS
###################################################################################
###################################################################################
add_action( 'add_meta_boxes', 'bandmanager_customBandMemberFields' );
add_action( 'save_post', 'bandmanager_bandmemberSaveFields' );
function bandmanager_customBandMemberFields() 
{
	add_meta_box('BandMemberInfoFields',__('Member Details', 'dx2bandtheme'),'bandmanager_BandMemberInfoFieldsCallback','bandmember','side');
	add_meta_box('BandMemberGear',__('Gear', 'dx2bandtheme'),'bandmanager_bandmembergear','bandmember','side');
}

function bandmanager_BandMemberInfoFieldsCallback($post)
{
	wp_nonce_field( 'customNBFieldsSaveMetaBoxData', 'customNBFieldsSaveMetaBoxNonce' );
	$instrument = get_post_meta( $post->ID, 'bandmember_instrument', true );
	$nickname = get_post_meta( $post->ID, 'bandmember_nickname', true );
	$datejoined = get_post_meta( $post->ID, 'bandmember_datejoined', true );
	$bandmember_dateleft = get_post_meta( $post->ID, 'bandmember_dateleft', true );
	?>
		<table class="bandmanagercustomfields">
			<tr><th>Instrument(s)</th></tr><tr><td><input type="text" name="bandmember_instrument" value="<?php echo $instrument;?>"></td></tr>
			<tr><th>Nick Name</th></tr><tr><td><input type="text" name="bandmember_nickname" value="<?php echo $nickname;?>"></td></tr>
			<tr><th>Date Joined</th></tr><tr><td><input type="text" class="datepicker" name="bandmember_datejoined" value="<?php echo $datejoined;?>"></td></tr>
			<tr><th>Date Left</th></tr><tr><td><input type="text" class="datepicker" name="bandmember_dateleft" value="<?php echo $bandmember_dateleft;?>" placeholder="leave blank if still present"></td></tr>
		</table>
	<?php
}

function bandmanager_bandmembergear($post)
{
	$Bandmember = Bandmember::Get()->ByPost($post);
	$allgear = $Bandmember->GetGear();
	if(count($allgear) == 0) echo "There is no gear assigned to this band member. You can assign a gear item to a band member from the edit page for the gear item.";
	foreach($allgear as $gear)
	{
		echo "<a href='/wp-admin/post.php?post=".$gear->ID."&action=edit'>".$gear->Title."</a><br>";
	}
}

function bandmanager_bandmemberSaveFields($post_id)
{
	global $post;
	if($post->post_type != "bandmember") return;
	if(bandmanager_validateMetaSave($post_id) == false) return;
	bandmanager_saveMetaField($post_id, "bandmember_instrument");
	bandmanager_saveMetaField($post_id, "bandmember_nickname");
	bandmanager_saveMetaField($post_id, "bandmember_datejoined");
	bandmanager_saveMetaField($post_id, "bandmember_dateleft");
}

###################################################################################
###################################################################################
#									ADMIN MENU
###################################################################################
###################################################################################
add_filter('manage_bandmember_posts_columns', 'bandmanager_bandmemberlist_columns');
function bandmanager_bandmemberlist_columns($columns){
	$columns = array(
		'cb' => '<input type="checkbox" />',
		'bandmember_image' => __('Image', 'dx2bandtheme'),
		'title' => __('Title', 'dx2bandtheme'),
		'bandmember_memberfrom' => __('Member From', "dx2bandtheme"),
		'date' => __('Date', 'dx2bandtheme'),
	);
	return $columns;
}

###################################################################################
###################################################################################
#								SHORTCODES
###################################################################################
###################################################################################

