<?php 
defined( 'ABSPATH' ) or die( 'Error' );
add_action( 'init', 'bandmanager_create_band_gear' );
function bandmanager_create_band_gear() {
	register_post_type( 'gear',
		array('labels' => array(
				'name' => 'Gear',
				'singular_name' => 'Gear',
				'add_new' => 'Add New',
				'add_new_item' => 'Add New Gear',
				'edit' => 'Edit',
				'edit_item' => 'Edit Gear',
				'new_item' => 'New Gear',
				'view' => 'View',
				'view_item' => 'View Gear',
				'search_items' => 'Search Gear',
				'not_found' => 'No Gear found',
				'not_found_in_trash' => 'No Gear found in Trash',
				'parent' => 'Parent Gear'
			),
 
			'public' => true,
			'menu_position' => 40,
			'supports' => array( 'title', 'editor', 'thumbnail', 'comments', 'revisions'),
			'taxonomies' => array( '' ),
			'menu_icon' => 'dashicons-admin-settings',
			'has_archive' => true
		)
	);
}

add_action( 'add_meta_boxes', 'bandmanager_customGearFields' );
add_action( 'save_post', 'bandmanager_gearSaveFields' );
function bandmanager_customGearFields() 
{
	add_meta_box('GearInfoFields',__('Details', 'dx2bandtheme'),'bandmanager_gearDetailsCallback','gear','side');
}
function bandmanager_gearSaveFields($post_id)
{
	global $post;
	if($post->post_type != "gear") return;
	if(bandmanager_validateMetaSave($post_id) == false) return;
	bandmanager_saveMetaField($post_id, "gear_bandmember");
	bandmanager_saveMetaField($post_id, "gear_model");
	bandmanager_saveMetaField($post_id, "gear_datepurchased");
	bandmanager_saveMetaField($post_id, "gear_yearmanufactured");
}

function bandmanager_gearDetailsCallback($post)
{
	wp_nonce_field( 'customNBFieldsSaveMetaBoxData', 'customNBFieldsSaveMetaBoxNonce' );
	$model = get_post_meta( $post->ID, 'gear_model', true );
	$datepurchased = get_post_meta( $post->ID, 'gear_datepurchased', true );
	$bandmember = get_post_meta( $post->ID, 'gear_bandmember', true );
	$gear_yearmanufactured = get_post_meta( $post->ID, 'gear_yearmanufactured', true );
	
	$args = array('post_type' => 'bandmember');
	$bandmemberlist = get_posts( $args ); 

	$bandmemberselect = "<option></option>";
	foreach($bandmemberlist as $member)
	{
		$selected = "";
		if($bandmember == $member->ID) $selected = "selected";		
		$bandmemberselect .= "<option value='".$member->ID."' ".$selected.">".$member->post_title."</option>";
	}
	$bandmemberselect = "<select name='gear_bandmember'>".$bandmemberselect."</select>";
	?>

	<table class="bandmanagercustomfields">
		<tr><th>Model</th></tr><tr><td><input type="text" name="gear_model" value="<?php echo $model;?>"></td></tr>
		<tr><th>Year Manufactured</th></tr><tr><td><input type="text" name="gear_yearmanufactured" value="<?php echo $gear_yearmanufactured;?>"></td></tr>
		<tr><th>Date Purchased</th></tr><tr><td><input class="datepicker" type="text" name="gear_datepurchased" value="<?php echo $datepurchased;?>"></td></tr>
		<tr><th>Band Member</th></tr><tr><td><?php echo $bandmemberselect;?></td></tr>
	</table>
	<?php 
}
###################################################################################
###################################################################################
#									ADMIN MENU
###################################################################################
###################################################################################
add_filter('manage_gear_posts_columns', 'bandmanager_gearlist_columns');
function bandmanager_gearlist_columns($columns){
	$columns = array(
		'cb' => '<input type="checkbox" />',
		'gear_artwork' => __('Image', 'dx2bandtheme'),
		'title' => __('Title', 'dx2bandtheme'),
		'gear_purchasedate' => __('Date Purchased', "dx2bandtheme"),
	);
	return $columns;
}