<?php 
defined( 'ABSPATH' ) or die( 'Error' );
add_action( 'init', 'bandmanager_create_gig' );
function bandmanager_create_gig() {
	register_post_type( 'gig',
		array('labels' => array(
				'name' => 'Gigs',
				'singular_name' => 'Gig',
				'add_new' => 'Add New',
				'add_new_item' => 'Add New Gig',
				'edit' => 'Edit',
				'edit_item' => 'Edit Gig',
				'new_item' => 'New Gig',
				'view' => 'View',
				'view_item' => 'View Gig',
				'search_items' => 'Search Gigs',
				'not_found' => 'No Gigs found',
				'not_found_in_trash' => 'No Gigs found in Trash',
				'parent' => 'Parent Gig'
			),
 
			'public' => true,
			'menu_position' => 40,
			'supports' => array( 'title', 'editor', 'thumbnail', 'comments', 'revisions' ),
			'taxonomies' => array( '' ),
			'menu_icon' => 'dashicons-tickets-alt',
			'has_archive' => true
		)
	);
} 
add_action('do_meta_boxes', 'bandmanager_change_image_box');
function bandmanager_change_image_box()
{
    remove_meta_box( 'postimagediv', 'gig', 'side' );
    add_meta_box('postimagediv', __('Gig Wallpaper', 'dx2bandtheme'), 'post_thumbnail_meta_box', 'gig', 'side', 'high');
}

add_action( 'add_meta_boxes', 'bandmanager_customGigFields' );
add_action( 'save_post', 'bandmanager_SaveGigFields' );
function bandmanager_customGigFields() 
{
	add_meta_box('GigInfoFields',__('Details', 'dx2bandtheme'),'bandmanager_gigDetailsCallback','gig','side');
}
function bandmanager_SaveGigFields($post_id)
{
	global $post;
	if($post->post_type != "gig") return;
	if(bandmanager_validateMetaSave($post_id) == false) return;
	bandmanager_saveMetaField($post_id, "gig_location");
	//saveMetaField($post_id, "gig_googlemaps");
	update_post_meta($post_id, "gig_googlemaps", $_POST["gig_googlemaps"]);
	bandmanager_saveMetaField($post_id, "gig_date");
	bandmanager_saveMetaField($post_id, "gig_doorsopen");
	bandmanager_saveMetaField($post_id, "gig_starttime");
	bandmanager_saveMetaField($post_id, "gig_admission");
	bandmanager_saveMetaField($post_id, "gig_agerestriction");
	bandmanager_saveMetaField($post_id, "gig_facebookurl");
	if(!isset($_POST['gig_fullimage'])) $_POST['gig_fullimage'] = "off";
	bandmanager_saveMetaField($post_id, "gig_fullimage");
	if(!isset($_POST['gig_fullimagetitle'])) $_POST['gig_fullimagetitle'] = "off";
	bandmanager_saveMetaField($post_id, "gig_fullimagetitle");
	bandmanager_saveMetaField($post_id, "gig_address");
	bandmanager_saveMetaField($post_id, "gig_endtime");
}

function bandmanager_gigDetailsCallback($post)
{
	wp_nonce_field( 'customNBFieldsSaveMetaBoxData', 'customNBFieldsSaveMetaBoxNonce' );
	$gig_location = get_post_meta( $post->ID, 'gig_location', true );
	$gig_googlemaps = get_post_meta( $post->ID, 'gig_googlemaps', true );
	$gig_date = get_post_meta( $post->ID, 'gig_date', true );
	$gig_doorsopen = get_post_meta( $post->ID, 'gig_doorsopen', true );
	$gig_starttime = get_post_meta( $post->ID, 'gig_starttime', true );
	$gig_admission = get_post_meta( $post->ID, 'gig_admission', true );
	$gig_agerestriction = get_post_meta( $post->ID, 'gig_agerestriction', true );
	$gig_facebookurl = get_post_meta( $post->ID, 'gig_facebookurl', true );
	$gig_ticketlimit = get_post_meta( $post->ID, 'gig_ticketlimit', true );
	$gig_address = get_post_meta( $post->ID, 'gig_address', true );
	?>

	<table class="bandmanagercustomfields">
		<tr><th>Location</th></tr><tr><td><input type="text" name="gig_location" value="<?php echo $gig_location;?>"></td></tr>
		<tr><th>Address</th></tr><tr><td><input type="text" name="gig_address" value="<?php echo $gig_address;?>"></td></tr>
		<tr><th>Google Maps Frame <a class="dx2themetip" target="_blank" href="https://dx2systems.com/wiki/gigs/">(Help)</a></th></tr><tr><td><input type="text" name="gig_googlemaps" value="<?php echo htmlentities($gig_googlemaps, ENT_QUOTES);?>"></td></tr>
		<tr><th>Date</th></tr><tr><td><input type="text" class="datepicker" name="gig_date" value="<?php echo $gig_date;?>"placeholder="yyyy-mm-dd"></td></tr>
		<tr><th>Doors Open</th></tr><tr><td><input type="text" name="gig_doorsopen" value="<?php echo $gig_doorsopen;?>"></td></tr>
		<tr><th>Start Time</th></tr><tr><td><input type="text" name="gig_starttime" value="<?php echo $gig_starttime;?>"></td></tr>
		<tr><th>Admission Cost</th></tr><tr><td><input type="text" name="gig_admission" value="<?php echo $gig_admission;?>"></td></tr>
		<tr><th>Ticket Limit</th></tr><tr><td><input type="text" name="gig_ticketlimit" value="<?php echo $gig_ticketlimit;?>"></td></tr>
		<tr><th>Age Restriction</th></tr><tr><td><input type="text" name="gig_agerestriction" value="<?php echo $gig_agerestriction;?>"></td></tr>
		<tr><th>Facebook Event URL</th></tr><tr><td><input type="text" name="gig_facebookurl" value="<?php echo $gig_facebookurl;?>"></td></tr>
	</table>
	<?php 
}