<?php 
defined( 'ABSPATH' ) or die( 'Error' );

//START DECLARE THE POST TYPE
add_action( 'init', 'bandmanager_create_songs' );
function bandmanager_create_songs() {
	register_post_type( 'song',
		array('labels' => array(
				'name' => 'Songs',
				'singular_name' => 'Song',
				'add_new' => 'Add New',
				'add_new_item' => 'Add New Song',
				'edit' => 'Edit',
				'edit_item' => 'Edit Song',
				'new_item' => 'New Song',
				'view' => 'View',
				'view_item' => 'View Songs',
				'search_items' => 'Search Songs',
				'not_found' => 'No Song found',
				'not_found_in_trash' => 'No Song found in Trash',
				'parent' => 'Parent Song'
			),
 
			'public' => true,
			'menu_position' => 40,
			'supports' => array( 'title', 'editor', 'thumbnail', 'comments', 'revisions' ),
			'taxonomies' => array( 'post_tag' ),
			//20x20pixels suits best
			'menu_icon' => 'dashicons-format-audio',
			'has_archive' => true
		)
	);
}
//END DECLARE THE POST TYPE

###################################################################################
###################################################################################
#									ADMIN MENU
###################################################################################
###################################################################################

add_filter('manage_song_posts_columns', 'bandmanager_songlist_columns');
function bandmanager_songlist_columns($columns){
	$columns = array_merge($columns, 
		array(
		'song_albumname' => __('Album', 'dx2-band-theme'),
	));
	return $columns;
}

###################################################################################
###################################################################################
#								META FIELDS
###################################################################################
###################################################################################

function bandmanager_customSongFields() {
	//call clientContactFieldsCallback and add the content from this function to any post types in the $screens variable
	add_meta_box('SongFields',__('Song Information', 'dx2bandtheme'),'bandmanager_songFieldsCallback', "song", 'side');
	if(get_option('bandmanager_showbandmembers') == "on") add_meta_box('BandMembers',__('Band Members', 'dx2bandtheme'),'bandmanager_bandMemberFieldsCallback', "song");
	add_meta_box('SongLyrics',__('Lyrics', 'dx2bandtheme'),'bandmanager_songLyricsCallback', "song");
	add_meta_box('SongFile',__('Upload Mp3', 'dx2bandtheme'),'bandmanager_uploadmp3', "song", 'side');
}
add_action( 'add_meta_boxes', 'bandmanager_customSongFields' );
//call this method when the post is saved. this adds everything to the DB
add_action( 'save_post', 'bandmanager_saveSongMetaData' );

//CALLBACK FUNCTIONS
function bandmanager_songLyricsCallback($post)
{
	$song_lyrics = get_post_meta( $post->ID, 'song_lyrics', true );
	wp_editor( $song_lyrics, 'song_lyrics', array(
    'wpautop'       => true,
    'media_buttons' => false,
    'textarea_name' => 'song_lyrics',
    'textarea_rows' => 10,
    'teeny'         => true
	) );
}
function bandmanager_songFieldsCallback($post)
{
	wp_nonce_field( 'customNBFieldsSaveMetaBoxData', 'customNBFieldsSaveMetaBoxNonce' );
	$song_albumid = get_post_meta( $post->ID, 'song_albumid', true );
	$song_tracknumber = get_post_meta( $post->ID, 'song_tracknumber', true );
	$song_tracklength = get_post_meta( $post->ID, 'song_tracklength', true );
	$song_daterecorded = get_post_meta( $post->ID, 'song_daterecorded', true );
	$song_itunes = get_post_meta( $post->ID, 'song_itunes', true );
	$song_amazon = get_post_meta( $post->ID, 'song_amazon', true );
	$song_soundcloud = get_post_meta( $post->ID, 'song_soundcloud', true );
	$song_youtube = get_post_meta( $post->ID, 'song_youtube', true );
	$song_locationrecorded = get_post_meta( $post->ID, 'song_locationrecorded', true );
	$song_googlemusic = get_post_meta( $post->ID, 'song_googlemusic', true );
	$song_spotify = get_post_meta( $post->ID, 'song_spotify', true );
	$song_albumimage = get_post_meta( $post->ID, 'song_albumimage', true );
	if($song_albumimage != "off") $song_albumimage = "on";
	
	$args = array('post_type' => 'album');
	$albumlist = get_posts( $args ); 

	$albumselectcontrol = "<option></option>";
	foreach($albumlist as $album)
	{
		$selected = "";
		if($song_albumid == $album->ID) $selected = "selected";
		
		$albumselectcontrol .= "<option value='".$album->ID."' ".$selected.">".$album->post_title."</option>";
	}
	$albumselectcontrol = "<select name='song_albumid'>".$albumselectcontrol."</select>";
	//var_dump($albumlist);
	?>
	<table id="songinfo_inputform">
		<tr><th>Album Name</th></tr><tr><td><?php echo $albumselectcontrol;?></td></tr>
		<tr><th>Track Number</th></tr><tr><td><input type="text" name="song_tracknumber" value="<?php echo $song_tracknumber;?>"></td></tr>
		<tr><th>Track Length</th></tr><tr><td><input type="text" name="song_tracklength" value="<?php echo $song_tracklength;?>"></td></tr>
		<tr><th>Date Recorded</th></tr><tr><td><input type="text" name="song_daterecorded" class="datepicker" value="<?php echo $song_daterecorded;?>"></td></tr>
		<tr><th>Location Recorded</th></tr><tr><td><input type="text" name="song_locationrecorded" value="<?php echo $song_locationrecorded;?>"></td></tr>
		<tr><th>iTunes URL</th></tr><tr><td><input type="text" name="song_itunes" value="<?php echo $song_itunes;?>"></td></tr>
		<tr><th>Amazon URL</th></tr><tr><td><input type="text" name="song_amazon" value="<?php echo $song_amazon;?>"></td></tr>
		<tr><th>Sound Cloud URL</th></tr><tr><td><input type="text" name="song_soundcloud" value="<?php echo $song_soundcloud;?>"></td></tr>
		<tr><th>Google Music URL</th></tr><tr><td><input type="text" name="song_googlemusic" value="<?php echo $song_googlemusic;?>"></td></tr>
		<tr><th>Spotify URL</th></tr><tr><td><input type="text" name="song_spotify" value="<?php echo $song_spotify;?>"></td></tr>
		<tr><th>YouTube URL</th></tr><tr><td><input type="text" name="song_youtube" placeholder="Use URL not iframe" value="<?php echo $song_youtube;?>"></td></tr>
		<tr><th>Use Album Image As Featured Image</th></tr><tr><td><input type="checkbox" name="song_albumimage" <?php if($song_albumimage == "on") echo "checked";?> style="width: 15px;"></td></tr>
	</table>
	<?php 
}

function bandmanager_bandMemberFieldsCallback($post)
{
	$args = array('post_type' => 'bandmember');
	$bandmemberlist = get_posts( $args ); 
	$bandmemberselect = "<option></option>";
	foreach($bandmemberlist as $member)
	{
		$bandmemberselect .= "<option value='".$member->ID."'>".$member->post_title."</option>";
	}
	$bandmemberselect = "<select id='addcomposerbandmember' name='addcomposerbandmember'>".$bandmemberselect."</select>";
	?>

	<div id="addBandMemberControl">
		<span id="closeAddBandMemberControl"><a href="javascript:toggleAddComposer()">X</a></span>
		<strong id="addBandMemberControlTitle">Add Composer To Song</strong><a class="dx2themetip" style="margin-left:10px;" title="View Page Type Documentation" target="_blank" href="https://dx2systems.com/wiki/adding-record-composers/"><span class="dashicons dashicons-lightbulb"></span> Help</a>
		<p>Add information about someone who played a part in the composition or production of this song below. The member field will link the composer to a band member</p>
		<table>
			<tr><td><div id="addcomposerimgpreview"></div></td></tr>
			<tr><th><a href="javascript:wpmediaupload('addcomposerimage','addcomposerimgpreview', 1)">Add Image</a></th></tr>
			<tr><th>Name</th></tr><tr><td><input type="text" id="addcomposername"></td></tr>
			<tr><th>Role Title</th></tr><tr><td><input type="text" id="addcomposerrole"></td></tr>
			<tr><th>Description</th></tr><tr><td><textarea id="addcomposerdescription"></textarea></td></tr>
			<tr><th>Member</th></tr><tr><td><?php echo $bandmemberselect;?></td></tr>
			<input type="hidden" name="addcomposerimage" id="addcomposerimage"></td></tr>
			<tr><td><input type="button" value="Submit" onclick="addNewComposer()"></td></tr>
		</table>
		<div style="clear:both"></div>
	</div>
	<div id="addComposerControls">
		<span style="float:right"><a href="javascript:toggleAddComposer()">Add New</a></span>
	</div>
	<div id="adminCurrentComposerList">
	<p>List of any people who contributed to this song in some way.</p>
		<?php 	
		$composermeta = get_post_meta( $post->ID, 'song_composers', true );
		$composers = json_decode($composermeta, true);
		//var_dump($composermeta);
		if(count($composers) == 0) echo "<p>No composers have been added to this song.</p>";
		else {
			$count = 1;
			foreach($composers as $composer)
			{
				?><div class='adminsongComposeTile' id='adminsongComposeTile<?php echo $count;?>'>
				<a class="composerRemove" href="javascript:deleteSongComposer(<?php echo $count;?>)">Remove</a>
				<table>
					<?php 
					if(isset($composer["image"]) && $composer["image"] != "") {
						echo '<tr><th><div id="composerimagepreview'.$count.'"><img src="'.$composer["image"].'"/></div></th></tr>';
						echo "<input type='hidden' id='composerimage".$count."' name='composerimage".$count."' value='".$composer["image"]."'>";
						echo "<a href='javascript:wpmediaupload(\"composerimage".$count."\",\"composerimagepreview".$count."\", 1)'>Change Image</a>";
					} 
					else {
						echo '<tr><th><div id="composerimagepreview'.$count.'"></div></th></tr>';
						echo "<input type='hidden' id='composerimage".$count."' name='composerimage".$count."'>";
						echo "<a href='javascript:wpmediaupload(\"composerimage".$count."\",\"composerimagepreview".$count."\", 1)'>Set Image</a>";	
					}?>
					<tr><th>Name</th></tr><tr><td><input type='text' name='composername<?php echo $count;?>' value='<?php echo $composer['name'];?>'></td></tr>
					<tr><th>Role</th></tr><tr><td><input type='text' name='composerrole<?php echo $count;?>' value='<?php echo $composer['role'];?>'></td></tr>
					<tr><th>Description</th></tr><tr><td><textarea name='composerdescription<?php echo $count;?>'><?php echo $composer['description'];?></textarea></td></tr>
					<tr><th>Band Member</th></tr><tr><td><select name='composerbandmember<?php echo $count;?>'>
					<?php 
						echo "<option></option>";
						foreach($bandmemberlist as $member) {
							$selected = "";
							if($member->ID == $composer['bandmember']) $selected = "selected";
							echo "<option value='".$member->ID."' ".$selected.">".$member->post_title."</option>";
						}
					?>
					</select></td></tr>
				</table></div>
				<?php
				$count ++;
			}
		}
		?>
	</div>
	<input type="hidden" id="totalExistingComposers" name= "totalExistingComposers" value="<?php echo count($composers);?>">
	<div style="clear:both"></div>
	<a class="dx2themetip" style="margin-left:10px;" title="View Page Type Documentation" target="_blank" href="https://dx2systems.com/wiki/adding-record-composers/"><span class="dashicons dashicons-lightbulb"></span> View Record Composer Documentation</a>
	<?php
}

function bandmanager_uploadmp3($post)
{
	$song_mp3path = get_post_meta( $post->ID, 'song_mp3path', true );
	?>
	<a class="dx2themetip" title="Help - Learn More about this section" href="https://dx2systems.com/wiki/albums-songs/#songssection"><span class="dashicons dashicons-lightbulb"></span>Help</a>
	<a style="float:right" href='javascript:wpmediauploadfile("song_mp3path")'>Upload Mp3</a><br>
	<table class="bandmanagercustomfields">
		<tr><th>MP3 Url</th></tr>
		<tr><td><input type="text" name="song_mp3path" id="song_mp3path" value="<?php echo $song_mp3path; ?>"></td></tr>
	</table>
	<?php
}

//this method will be called when the user saves the post. this will insert everything into the DB
function bandmanager_saveSongMetaData($post_id) 
{
	//these are all custom functions to make the code a lot tidier and shorter.
	global $post;
	if($post->post_type != "song") return;
	
	if(bandmanager_validateMetaSave($post_id) == false) return;
	bandmanager_saveMetaField($post_id, "song_albumid");
	bandmanager_saveMetaField($post_id, "song_tracknumber");
	bandmanager_saveMetaField($post_id, "song_tracklength");
	bandmanager_saveMetaField($post_id, "song_daterecorded");
	bandmanager_saveMetaField($post_id, "song_itunes");
	bandmanager_saveMetaField($post_id, "song_amazon");
	bandmanager_saveMetaField($post_id, "song_soundcloud");
	bandmanager_saveMetaField($post_id, "song_youtube");
	if(!isset($_POST['song_albumimage'])) $_POST['song_albumimage'] = "off";
	bandmanager_saveMetaField($post_id, "song_albumimage");
	bandmanager_saveMetaField($post_id, "song_locationrecorded");
	bandmanager_saveMetaField($post_id, "song_googlemusic");
	bandmanager_saveMetaField($post_id, "song_spotify");
	bandmanager_saveMetaField($post_id, "song_mp3path");
	
	$lyrics = wpautop(wptexturize($_POST["song_lyrics"]));

	update_post_meta($post_id, "song_lyrics", $lyrics);
	
	$composerdivids = array();
	$composers = array();
	foreach($_POST as $key => $val)
	{
		//echo substr($key, 0, 12)."<br>";
		if(substr($key, 0, 12) == "composername") 
		{
			$currentindexid = substr($key, 12, 13);
			$composerdivids[] = $currentindexid;
			$composer = array();
			$composer["name"] = $_POST['composername'.$currentindexid];
			$composer["role"] = $_POST['composerrole'.$currentindexid];
			$composer["description"] = $_POST['composerdescription'.$currentindexid];
			$composer["bandmember"] = $_POST["composerbandmember".$currentindexid];
			$composer["image"] = "";
			if(isset($_POST["composerimage".$currentindexid])) $composer["image"] = $_POST["composerimage".$currentindexid];
			$composers[] = $composer;
		}
	}
	update_post_meta($post_id, "song_composers", sanitize_text_field(json_encode($composers)));
}

###################################################################################
###################################################################################
#								SHORTCODES
###################################################################################
###################################################################################