<?php 
defined( 'ABSPATH' ) or die( 'Error' );
add_action( 'init', 'bandmanager_create_testimonials' );
function bandmanager_create_testimonials() {
	register_post_type( 'testimonial',
		array('labels' => array(
				'name' => 'Testimonials',
				'singular_name' => 'Testimonial',
				'add_new' => 'Add New',
				'add_new_item' => 'Add New Testimonial',
				'edit' => 'Edit',
				'edit_item' => 'Edit Testimonial',
				'new_item' => 'New Testimonial',
				'view' => 'View',
				'view_item' => 'View Testimonial',
				'search_items' => 'Search Testimonials',
				'not_found' => 'No Testimonials found',
				'not_found_in_trash' => 'No Testimonials found in Trash',
				'parent' => 'Parent Testimonial'
			),
 
			'public' => true,
			'menu_position' => 40,
			'supports' => array( 'title', 'editor', 'revisions' ),
			'taxonomies' => array( '' ),
			'menu_icon' => 'dashicons-megaphone',
			'has_archive' => true
		)
	);
}

###################################################################################
###################################################################################
#								META FIELDS
###################################################################################
###################################################################################
add_action( 'add_meta_boxes', 'bandmanager_customTestimonialFields' );
add_action( 'save_post', 'bandmanager_testimonialSaveFields' );
function bandmanager_customTestimonialFields() {
    //call clientContactFieldsCallback and add the content from this function to any post types in the $screens variable
	add_meta_box('TestimonialFields', __('Contact Source', 'dx2bandtheme'),'bandmanager_testimonialFieldsCallback', "testimonial", 'side'
	);
}

function bandmanager_testimonialFieldsCallback($post)
{
	wp_nonce_field( 'customNBFieldsSaveMetaBoxData', 'customNBFieldsSaveMetaBoxNonce' );
	$testimonial_date = get_post_meta( $post->ID, 'testimonial_date', true );
	$testimonial_contactname = get_post_meta( $post->ID, 'testimonial_contactname', true );
	//Date, Person Name, Gig name
	?>
	<table class="bandmanagercustomfields">
		<tr><th>Date</th></tr><tr><td><input type="text" name="testimonial_date" id="datepicker" value="<?php echo $testimonial_date;?>"></td></tr>
		<tr><th>Contact Name</th></tr><tr><td><input type="text" name="testimonial_contactname" id="datepicker" value="<?php echo $testimonial_contactname;?>"></td></tr>
	</table>
	<?php
}

function bandmanager_testimonialSaveFields($post_id)
{
	if(validateMetaSave($post_id) == false) return;
	saveMetaField($post_id, "testimonial_date");
	saveMetaField($post_id, "testimonial_contactname");
}

###################################################################################
###################################################################################
#								SHORTCODES
###################################################################################
###################################################################################