<?php
defined( 'ABSPATH' ) or die( 'Error' );
class band_album_widget extends WP_Widget 
{
	function __construct() 
	{
		parent::__construct('band_album_widget', __('Album Listing', 'dx2bandtheme'), array( 'description' => __( 'Will display a listing of your bands albums.', 'dx2bandtheme' )));
	}
	public function widget( $args, $instance ) 
	{
		if(isset($instance["albumquerytype"]) && $instance["albumquerytype"] != "")
		{
		?>
		<aside id="albums_widget" class="widget widget_meta"><h2 class="widget-title"><?php echo $instance['title'];?></h2>
			<?php 
				$queryargs = array('post_type' => 'album');
				
				switch($instance["albumquerytype"])
				{
					case "albumsingle": 
						if(!isset($instance["albumslug"]) || trim($instance["albumslug"]) == "") $instance["albumslug"] = "xx-missing-xx";
						$queryargs["name"] = $instance["albumslug"];
						$queryargs["posts_per_page"] = 1;
					break;
					
					case "albumlist":
						$queryargs["posts_per_page"] = $instance['limit'];
						$queryargs["post_status"] = 'publish';
						$orderby = array();
						switch($instance["orderby"])
						{
							case "releasedateasc":
								$orderby = array(
									'orderby' 	=>	'meta_value',
									'meta_key' 	=>	'album_releasedate',
									'order'		=>	'ASC'
								);
							break;
							case "releasedatedesc":
								$orderby = array(
									'orderby' 	=>	'meta_value',
									'meta_key' 	=>	'album_releasedate',
									'order'		=>	'DESC'
								);
							break;
							case "alphaetic":
								$orderby = array(
									'orderby' 	=>	'title',
									'order'		=>	'ASC'
								);
							break;
						}
							
						$queryargs = array_merge($queryargs, $orderby);
					break;
				}

				$albumlist = get_posts( $queryargs ); 
				foreach($albumlist as $album)
				{
					$Album = Album::Get()->ByPost($album);
					switch($instance['template'])
					{
						case "minimal":
							echo bandmanager_getPrettyDate($Album->ReleaseDate).' - <a href="/album/'.$Album->Slug.'" itemprop="url"><span itemprop="name">'.$Album->Title.'</span></a>';
						break;
						
						case "basic":
							?>
							<div class="basicalbumtile">
								<img src="<?php echo $Album->GetThumbnail(false);?>" itemprop="image" alt="<?php echo $Album->Title;?> Album Cover">
								<a href="/album/<?php echo $Album->Slug;?>" itemprop="url"><span itemprop="name"><strong><?php echo $Album->Title;?></strong></span></a><br>
								Released : <?php echo bandmanager_getPrettyDate($Album->ReleaseDate);?><br>
								Tracks : <span itemprop="numTracks"><?php echo $Album->GetSongCount();?></span>
							</div>
							<?php 
						break;
						
						case "detailed":
						?>
							<div class="widgetalbum" itemscope itemtype="http://schema.org/MusicAlbum">						
								<div class="widgetalbumcover"><a href="/album/<?php echo $Album->Slug;?>"><img src="<?php echo $Album->GetThumbnail(false);?>" itemprop="image" alt="<?php echo $Album->Title;?> Album Cover"></a></div>
								<div class="widgetalbumtitle"><a href="/album/<?php echo $Album->Slug;?>" itemprop="url"><span itemprop="name"><?php echo $Album->Title;?></span></a></div>
								<strong>Released : </strong><?php echo bandmanager_getPrettyDate($Album->ReleaseDate);?><br>
								<strong>Tracks : </strong><span itemprop="numTracks"><?php echo $Album->GetSongCount();?></span><br>
								<div id="widgetalbumpurchaselinks">
								<?php 
									if($Album->Itunes != "") echo "<a href='".$Album->Itunes."'><i class='fa fa-apple'></i></a>";
									if($Album->Amazon != "") echo "<a href='".$Album->Amazon."'><i class='fa fa-amazon'></i></a>";
									if($Album->SoundCloud != "") echo "<a href='".$Album->SoundCloud."'><i class='fa fa-soundcloud'></i></a>";
									if($Album->GoogleMusic != "") echo "<a href='".$Album->GoogleMusic."'><i class='fa fa-google'></i></a>";
									if($Album->Spotify != "") echo "<a href='".$Album->Spotify."'><i class='fa fa-spotify'></i></a>";
								?>
								</div>
								<span itemprop="genre"><?php echo $album->Genre; ?></span>
								<span itemprop="byArtist" itemscope itemtype="http://schema.org/MusicGroup"><span itemprop="name" content="<?php echo get_option('band_name');?>"></span></span>
								<div style="clear:both"></div>
							</div>						
						<?php 
						break;
					}
				}
			
			?>
			<div style="clear:both"></div>
		</aside>
		<?php
		}		
	}
	public function form( $instance ) {
		if ( isset( $instance[ 'title' ] ) ) 
		{
			$title = $instance[ 'title' ];
			$limit = $instance[ 'limit' ];
			$template = $instance['template'];
			$albumquerytype = $instance['albumquerytype'];
			$orderby = $instance['orderby'];
			$albumslug = $instance['albumslug'];
		}
		else {
			$title = __( '', 'dx2bandtheme' );
			$limit = __( '5', 'dx2bandtheme');
			$template = 'detailed';
			$albumquerytype = 'albumlist';
			$orderby = 'releasedateasc';
			$albumslug = "";
		}
		// Widget admin form
		?>
		<div id="albumwidgetform<?php echo $this->number;?>">
			<label for="<?php echo $this->get_field_id( 'title' ); ?>">Title:</label> 
			<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" /><br>
			<label for="<?php echo $this->get_field_id( 'albumquerytype' ); ?>">Query Type</label>
			<select class="widefat" id="albumquerytype" name="<?php echo $this->get_field_name( 'albumquerytype' ); ?>" onchange="showAlbumQueryTypeFields(<?php echo $this->number;?>)">
				<option value="albumlist" <?php if($albumquerytype=="albumlist") echo "selected";?>>Album List</option>
				<option value="albumsingle" <?php if($albumquerytype=="albumsingle") echo "selected";?>>Single Album</option>
			</select>
				<div id="albumlist" class="drilldownfields">
					<label for="<?php echo $this->get_field_id( 'limit' ); ?>">Limit</label> 
					<input class="widefat" id="<?php echo $this->get_field_id( 'limit' ); ?>" name="<?php echo $this->get_field_name( 'limit' ); ?>" type="text" value="<?php echo esc_attr( $limit ); ?>" /><br>
					
					<label for="<?php echo $this->get_field_id( 'orderby' ); ?>">Order By</label>
					<select class="widefat" id="<?php echo $this->get_field_id( 'orderby' ); ?>" name="<?php echo $this->get_field_name( 'orderby' ); ?>">
						<option value="releasedateasc" <?php if($orderby=="releasedateasc") echo "selected";?>>Release Date ASC</option>
						<option value="releasedatedesc" <?php if($orderby=="releasedatedesc") echo "selected";?>>Release Date DESC</option>
						<option value="alphaetic" <?php if($orderby=="alphaetic") echo "selected";?>>Alphabetic</option>
					</select>
				</div>
				<div id="albumsingle" class="drilldownfields">
					<label for="<?php echo $this->get_field_id( 'albumslug' ); ?>">Album Slug</label> 
					<input class="widefat" id="<?php echo $this->get_field_id( 'albumslug' ); ?>" name="<?php echo $this->get_field_name( 'albumslug' ); ?>" type="text" value="<?php echo esc_attr( $albumslug ); ?>" /><br>
				</div>
			<label for="<?php echo $this->get_field_id( 'template' ); ?>">Template</label>
			<select class="widefat" id="<?php echo $this->get_field_id( 'template' ); ?>" name="<?php echo $this->get_field_name( 'template' ); ?>">
				<option value="minimal" <?php if($template=="minimal") echo "selected";?>>Minimal</option>
				<option value="basic" <?php if($template=="basic") echo "selected";?>>Basic</option>
				<option value="detailed" <?php if($template=="detailed") echo "selected";?>>Detailed</option>
			</select>
		</div>
		<?php 
	}
	public function update( $new_instance, $old_instance ) 
	{
		$instance = array();
		$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
		$instance['limit'] = ( ! empty( $new_instance['limit'] ) ) ? strip_tags( $new_instance['limit'] ) : '';
		$instance['template'] = strip_tags( $new_instance['template']);
		$instance['albumquerytype'] = ( ! empty( $new_instance['albumquerytype'] ) ) ? strip_tags( $new_instance['albumquerytype'] ) : '';
		$instance['orderby'] = ( ! empty( $new_instance['orderby'] ) ) ? strip_tags( $new_instance['orderby'] ) : '';
		$instance['albumslug'] = ( ! empty( $new_instance['albumslug'] ) ) ? strip_tags( $new_instance['albumslug'] ) : '';;
		return $instance;
	}
}
function load_album_widget() {
	register_widget( 'band_album_widget' );
}
add_action( 'widgets_init', 'load_album_widget' );